diff --git a/src/server/ua_services_discovery.c b/src/server/ua_services_discovery.c
index ada5b385baa..c126a2286e2 100644
--- a/src/server/ua_services_discovery.c
+++ b/src/server/ua_services_discovery.c
@@ -773,7 +773,7 @@ process_RegisterServer(UA_Server *server, UA_Session *session, const UA_RequestH
         }
 
         if (server->registerServerCallback) {
-            server->registerServerCallback(&registeredServer_entry->registeredServer, server->registerServerCallbackData);
+            server->registerServerCallback(requestServer, server->registerServerCallbackData);
         }
 
         // server found, remove from list
@@ -813,7 +813,7 @@ process_RegisterServer(UA_Server *server, UA_Session *session, const UA_RequestH
 #endif
 
         if (server->registerServerCallback) {
-            server->registerServerCallback(&registeredServer_entry->registeredServer, server->registerServerCallbackData);
+            server->registerServerCallback(requestServer, server->registerServerCallbackData);
         }
 
     } else {
